package net.roseindia.apps;

import java.util.Iterator;
import java.util.List;

import net.roseindia.table.Address;
import net.roseindia.table.Student;
import net.roseindia.util.HibernateUtil;

import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;

public class MyApp {

	public static void main(String[] args) {
		Session session = HibernateUtil.getSessionFactory().openSession();
		Transaction transaction = null;
		try {
			/*
			 * transaction = session.beginTransaction(); Address address = new
			 * Address("B9", "Rohini", "Delhi");
			 * 
			 * Student ram = new Student("Ram", address); Student syam = new
			 * Student("Syam", address); session.save(ram); session.save(syam);
			 * 
			 * transaction.commit();
			 */

			/* Left Join */
			// String hql = "from Student s left join s.address as obj";

			/* Right Join */
			// String hql = "from Student s Right Join s.address as obj";

			/* Right Join */
			// String hql = "from Student s Inner Join s.address as obj";

			/* Join */
			String hql = "from Student s Join s.address as obj";

			Query query = session.createQuery(hql);
			List lists = query.list();
			Iterator iterator = lists.iterator();
			System.out.println("Name \tRoll \tAddress Id \tAddress");
			while (iterator.hasNext()) {
				System.out.println();
				Object[] objects = (Object[]) iterator.next();
				for (int i = 0; i < objects.length; i++) {
					Object obj = objects[i];
					if (obj instanceof Student) {
						Student s = (Student) obj;
						System.out.print(s.getStudentName() + "\t"
								+ s.getRollNo());
					}
					if (obj instanceof Address) {
						Address a = (Address) obj;
						System.out.print("\t" + a.getAddressId() + "\t"
								+ a.getCity());
					}
				}
			}
		} catch (HibernateException e) {
			transaction.rollback();
			e.printStackTrace();
		} finally {
			session.close();
		}

	}

}
